import numpy as np
import matplotlib.pyplot as plt
plt.close('all')

c=0.1
c0=0.1
c1=1e-3
V0=10e-3

E0I=0.62
E0S=0.09
E1=1.02


U=[]

volumes=np.linspace(0,40e-3,1000)
for V in volumes:
    if V<2*c0*V0/c:
        xi=c*V/2
        U.append(E1-(E0I+0.03*np.log10((c0*V0-xi)*(V0+V)/(c1*V0+2*xi)**2)))
    else:
        xi=c0*V0
        U.append(E1-(E0S+0.03*np.log10(xi*(V0+V)/(c*V-2*xi)**2)))

DU=[]
for i in range(1,len(U)-1):
    DU.append((U[i+1]-U[i-1])/(volumes[i+1]-volumes[i-1]))
 
plt.subplot(121)
plt.plot(volumes,U)
plt.title('fem aux bornes de la pile')
plt.xlabel('Volume de thiosulfate versé (en L)')
plt.ylabel('Tension (en V)')

plt.subplot(122)
plt.plot(volumes[1:-1],DU)
plt.title('Dérivée de la tension par rapport au volume versé')
plt.xlabel('Volume de thiosulfate versé (en L)')
plt.ylabel('$\dfrac{dU}{dV}$')
plt.show()

def maxi(liste):
    m=liste[0]
    pos=0
    for i in range(len(liste)):
        if liste[i]>m:
            m=liste[i]
            pos=i
    return pos

print("Volume à l'équivalence = ", format(volumes[maxi(DU)+1],'.2e'), 'L')
